# sapling

sapling is a "micro-language" that I'm working on to investigate [Tree Calculus](https://github.com/barry-jay-personal/typed_tree_calculus/blob/main/typed_program_analysis.pdf) .

It offers a minimal amount of syntax sugar:

- `t` operator behaving by the rules of Tree Calculus
- Variable definitions
- Lambda abstractions
- List, Integer, and String literals

This is an active experimentation project by [someone who has no idea what they're doing](https://eversole.co).

## Acknowledgements 

Tree Calculus was discovered by [Barry Jay](https://github.com/barry-jay-personal/blog). 

[treecalcul.us](https://treecalcul.us) is an excellent website with an intuitive playground created by [Johannes Bader](https://johannes-bader.com/) that introduced me to Tree Calculus. If sapling sounds interesting but compiling this repo sounds like a hassle, you should check out his site.
